package holeg.power_flow;

public class TestData {
    public static Bus[] getIEEE14Busses() {
        return new Bus[]{
                new Bus(1.06, 0, 0, 0, 0, 0, 0, 0, BusType.Slack), // 1
                new Bus(1.045, 0, 40, 42.4, 21.7, 12.7, -40, 50, BusType.PV), // 2
                new Bus(1.010, 0, 0, 23.4, 94.2, 19.0, 0, 40, BusType.PV), // 3
                new Bus(1.0, 0, 0, 0, 47.8, -3.9, 0, 0, BusType.PQ), // 4
                new Bus(1.0, 0, 0, 0, 7.6, 1.6, 0, 0, BusType.PQ), // 5
                new Bus(1.070, 0, 0, 12.2, 11.2, 7.5, -6, 24, BusType.PV), // 6
                new Bus(1.0, 0, 0, 0, 0.0, 0.0, 0, 0, BusType.PQ), // 7
                new Bus(1.090, 0, 0, 17.4, 0.0, 0.0, -6, 24, BusType.PV), // 8
                new Bus(1.0, 0, 0, 0, 29.5, 16.6, 0, 0, BusType.PQ), // 9
                new Bus(1.0, 0, 0, 0, 9.0, 5.8, 0, 0, BusType.PQ), // 10
                new Bus(1.0, 0, 0, 0, 3.5, 1.8, 0, 0, BusType.PQ), // 11
                new Bus(1.0, 0, 0, 0, 6.1, 1.6, 0, 0, BusType.PQ), // 12
                new Bus(1.0, 0, 0, 0, 13.5, 5.8, 0, 0, BusType.PQ),  // 13
                new Bus(1.0, 0, 0, 0, 14.9, 5.0, 0, 0, BusType.PQ) // 14
        };
    }

    public static Bus[] getIEEE14BussesSameVoltages() {
        return new Bus[]{
                new Bus(1.0, 0, 0, 0, 0, 0, 0, 0, BusType.Slack),
                new Bus(1.0, 0, 40, 42.4, 21.7, 12.7, -40, 50, BusType.PV),
                new Bus(1.0, 0, 0, 23.4, 94.2, 19.0, 0, 40, BusType.PV),
                new Bus(1.0, 0, 0, 0, 47.8, -3.9, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 7.6, 1.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 12.2, 11.2, 7.5, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 0.0, 0.0, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 17.4, 0.0, 0.0, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 29.5, 16.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 9.0, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 3.5, 1.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 6.1, 1.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 13.5, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 14.9, 5.0, 0, 0, BusType.PQ)
        };
    }

    public static Bus[] getIEEE14BussesNoGeneration() {
        return new Bus[]{
                new Bus(1.0, 0, 0, 0, 0, 0, 0, 0, BusType.Slack),
                new Bus(1.0, 0, 0, 0, 21.7, 12.7, -40, 50, BusType.PV),
                new Bus(1.0, 0, 0, 0, 94.2, 19.0, 0, 40, BusType.PV),
                new Bus(1.0, 0, 0, 0, 47.8, -3.9, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 7.6, 1.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 12.2, 11.2, 7.5, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 0.0, 0.0, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 17.4, 0.0, 0.0, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 29.5, 16.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 9.0, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 3.5, 1.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 6.1, 1.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 13.5, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 14.9, 5.0, 0, 0, BusType.PQ)
        };
    }

    public static Bus[] getIEEE14BussesHugeGeneration() {
        return new Bus[]{
                new Bus(1.06, 0, 0, 0, 0, 0, 0, 0, BusType.Slack),
                new Bus(1.045, 0, 40, 42.4, 21.7, 12.7, -40, 50, BusType.PV),
                new Bus(1.010, 0, 100, 23.4, 94.2, 19.0, 0, 40, BusType.PV),
                new Bus(1.0, 0, 0, 0, 47.8, -3.9, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 7.6, 1.6, 0, 0, BusType.PQ),
                new Bus(1.070, 0, 0, 12.2, 11.2, 7.5, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 0.0, 0.0, 0, 0, BusType.PQ),
                new Bus(1.090, 0, 500, 17.4, 0.0, 0.0, -6, 24, BusType.PV),
                new Bus(1.0, 0, 0, 0, 29.5, 16.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 9.0, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 3.5, 1.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 6.1, 1.6, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 13.5, 5.8, 0, 0, BusType.PQ),
                new Bus(1.0, 0, 0, 0, 14.9, 5.0, 0, 0, BusType.PQ)
        };
    }

    public static Line[] getIEEE14Lines() {
        return new Line[]{
                new Line(1, 2, 0.01938, 0.05917, 0.0264, 1), // 0
                new Line(1, 5, 0.05403, 0.22304, 0.0246, 1), // 1
                new Line(2, 3, 0.04699, 0.19797, 0.0219, 1), // 2
                new Line(2, 4, 0.05811, 0.17632, 0.0170, 1), // 3
                new Line(2, 5, 0.05695, 0.17388, 0.0173, 1), // 4
                new Line(3, 4, 0.06701, 0.17103, 0.0064, 1), // 5
                new Line(4, 5, 0.01335, 0.04211, 0.0, 1), // 6
                new Line(4, 7, 0.0, 0.20912, 0.0, 0.978), // 7
                new Line(4, 9, 0.0, 0.55618, 0.0, 0.969), // 8
                new Line(5, 6, 0.0, 0.25202, 0.0, 0.932), // 9
                new Line(6, 11, 0.09498, 0.19890, 0.0, 1), // 10
                new Line(6, 12, 0.12291, 0.25581, 0.0, 1), // 11
                new Line(6, 13, 0.06615, 0.13027, 0.0, 1), // 12
                new Line(7, 8, 0.0, 0.17615, 0.0, 1), // 13
                new Line(7, 9, 0.0, 0.11001, 0.0, 1), // 14
                new Line(9, 10, 0.03181, 0.08450, 0.0, 1), // 15
                new Line(9, 14, 0.12711, 0.27038, 0.0, 1), // 16
                new Line(10, 11, 0.08205, 0.19207, 0.0, 1), // 17
                new Line(12, 13, 0.22092, 0.19988, 0.0, 1), // 18
                new Line(13, 14, 0.17093, 0.34802, 0.0, 1) // 19
        };
    }

    public static Line[] getIEEE14LinesNoConnectionToSlack() {
        return new Line[]{
                new Line(2, 3, 0.04699, 0.19797, 0.0219, 1),
                new Line(2, 4, 0.05811, 0.17632, 0.0170, 1),
                new Line(2, 5, 0.05695, 0.17388, 0.0173, 1),
                new Line(3, 4, 0.06701, 0.17103, 0.0064, 1),
                new Line(4, 5, 0.01335, 0.04211, 0.0, 1),
                new Line(4, 7, 0.0, 0.20912, 0.0, 0.978),
                new Line(4, 9, 0.0, 0.55618, 0.0, 0.969),
                new Line(5, 6, 0.0, 0.25202, 0.0, 0.932),
                new Line(6, 11, 0.09498, 0.19890, 0.0, 1),
                new Line(6, 12, 0.12291, 0.25581, 0.0, 1),
                new Line(6, 13, 0.06615, 0.13027, 0.0, 1),
                new Line(7, 8, 0.0, 0.17615, 0.0, 1),
                new Line(7, 9, 0.0, 0.11001, 0.0, 1),
                new Line(9, 10, 0.03181, 0.08450, 0.0, 1),
                new Line(9, 14, 0.12711, 0.27038, 0.0, 1),
                new Line(10, 11, 0.08205, 0.19207, 0.0, 1),
                new Line(12, 13, 0.22092, 0.19988, 0.0, 1),
                new Line(13, 14, 0.17093, 0.34802, 0.0, 1)
        };
    }
}
